### Navigation

- index
- modules |
- next |
- previous |
- home|
- search|
- documentation »
- The IPython API »

# utils.jsonutil

## Module: `utils.jsonutil`

Utilities to manipulate JSON objects.

## Functions

`IPython.utils.jsonutil.``date_default`(obj)

  default function for packing datetime objects in JSON.

`IPython.utils.jsonutil.``extract_dates`(obj)

  extract ISO8601 dates from unpacked JSON

`IPython.utils.jsonutil.``json_clean`(obj)

  Clean an object to ensure it’s safe to encode in JSON.

  Atomic, immutable objects are returned unmodified. Sets and tuples are converted to lists, lists are copied and dicts are also copied.

  Note: dicts whose keys could cause collisions upon encoding (such as a dict with both the number 1 and the string ‘1’ as keys) will cause a ValueError to be raised.

  Parameters : | obj : any python object

  Returns :

  out : object

  > A version of the input which will not cause an encoding error when encoded as JSON. Note that this function does not encode its inputs, it simply sanitizes it so that there will be no encoding errors later.

  Examples

      >>> json_clean(4)
      4
      >>> json_clean(range(10))
      [0, 1, 2, 3, 4, 5, 6, 7, 8, 9]
      >>> json_clean(dict(x=1, y=2))
      {'y': 2, 'x': 1}
      >>> json_clean(dict(x=1, y=2, z=[1,2,3]))
      {'y': 2, 'x': 1, 'z': [1, 2, 3]}
      >>> json_clean(True)
      True

`IPython.utils.jsonutil.``rekey`(dikt)

  Rekey a dict that has been forced to use str keys where there should be ints by json.

`IPython.utils.jsonutil.``squash_dates`(obj)

  squash datetime objects into ISO8601 strings

### Navigation

- index
- modules |
- next |
- previous |
- home|
- search|
- documentation »
- The IPython API »